#include "Main.h"
#include "Collision.h"
#include "ColSegment.h"
#include <math.h>

CCollision::CCollision(RECT col, float offset_l, float offset_u, float offset_r, float offset_d, int col_type, CGameMain* game)
	:mcol(col),OffsetL(offset_l), OffsetU(offset_u), OffsetR(offset_r), OffsetD(offset_d), ColType(col_type) {
	Game = game;
}

Vector2 CCollision::GetMatrixPos(float myx, float myy) {
	DWORD cwidth = Game->MapData().GetChipWidth();
	DWORD cheight = Game->MapData().GetChipHeight();
	int x = (int)(myx / cwidth);
	int y = (int)(myy / cheight);
	return Vector2((float)x * cwidth, (float)y * cheight);
}
bool CCollision::RectCollision(RECT r1, RECT r2) {
	if (r1.left <= r2.right&&
		r1.top <= r2.bottom&&
		r1.right >= r2.left&&
		r1.bottom >= r2.top) return true;

	return false;
}

POINT CCollision::CheckMap(int x, int y) {
	//蔻B
	RECT col = {
		x + mcol.left,
		y + mcol.top,
		x + mcol.right,
		y + mcol.bottom
	};
	DWORD width = Game->MapData().GetMapWidth();
	DWORD height = Game->MapData().GetMapHeight();
	DWORD cwidth = Game->MapData().GetChipWidth();
	DWORD cheight = Game->MapData().GetChipHeight();
	POINT res = { x,y };
	//⓹̓蔻肪̂ȂA-2ԂB
	int indexslope = GetChipLayerNum(x, y);
	if (indexslope != 0) {
		res.x = -2;
		res.y = -2;
		return res;
	}
	for (DWORD mapy = 0; mapy < height; mapy++) {
		for (DWORD mapx = 0; mapx < width; mapx++) {
			RECT bcol;
			//C[1lp`B
			int index = Game->MapData().GetValue(1, x / cwidth, y / cheight);
			//΂ߏ̔B
			int src_x = (index % Game->GetBitCount()) * cwidth;
			int src_y = (index / Game->GetBitCount()) * cheight;
			if (src_x == 0 && src_y == 0) {
				bcol.left = cwidth*mapx;
				bcol.top = cheight*mapy;
				bcol.right = bcol.left + cwidth;
				bcol.bottom = bcol.top + cheight;
			}
			else {
				goto nohit;
			}
			//⓹̓蔻肪Ȃ͏̓蔻sB
			if (RectCollision(col,bcol)) {
				res.x = mapx; // ǂ̍W
				res.y = mapy;
				return res; // ǂ̍WԂ
			}
		}
	}
nohit:
	res.x = -1;//܂ŗ瓖ĂȂƂ
	res.y = -1;
	return res;
}

int CCollision::GetChipLayerNum(int x, int y) {
	POINT pt[] = {
		{ x + mPt[0].x,	y + mPt[0].y },//
		{ x + mPt[1].x,	y + mPt[1].y },//^
		{ x + mPt[2].x,	y + mPt[2].y },//E

		{ x + mPt[3].x,	y + mPt[3].y },//^
		{ x + mPt[4].x,	y + mPt[4].y },//E^

		{ x + mPt[5].x,	y + mPt[5].y },//
		{ x + mPt[6].x,	y + mPt[6].y },//^
		{ x + mPt[7].x,	y + mPt[7].y },//E
	};
	DWORD cwidth = Game->MapData().GetChipWidth();
	DWORD cheight = Game->MapData().GetChipHeight();
	//forŏsĂ̂́A蔻̃C[邩ȂB
	for (int i = 0; i <= MaxLayerNum; i++) {
		for (int j = 0; j < 8; j++) {
			int index = Game->MapData().GetValue(i + 2, pt[j].x / cwidth, pt[j].y / cheight);
			int src_x = (index % Game->GetBitCount()) * cwidth;
			int src_y = (index / Game->GetBitCount()) * cheight;
			//CԍɁAՓ˂ĂB
			if (src_x == 0 && src_y == 0) {
				//C[ԍԂB
				return i + 2;
			}
		}
	}
	//Ô߁B
	return 0;
}

POINT CCollision::CheckSlopeBlock(int x, int y, int layernum) {
	POINT pt[] = {
		{ x + mPt[0].x,	y + mPt[0].y },//
		{ x + mPt[1].x,	y + mPt[1].y },//^
		{ x + mPt[2].x,	y + mPt[2].y },//E

		{ x + mPt[3].x,	y + mPt[3].y },//^
		{ x + mPt[4].x,	y + mPt[4].y },//E^

		{ x + mPt[5].x,	y + mPt[5].y },//
		{ x + mPt[6].x,	y + mPt[6].y },//^
		{ x + mPt[7].x,	y + mPt[7].y },//E
	};
	POINT res = { x,y };
	DWORD cwidth = Game->MapData().GetChipWidth();
	DWORD cheight = Game->MapData().GetChipHeight();
	for(int i = 0; i < 8; i++){
		int index = Game->MapData().GetValue(layernum , pt[i].x / cwidth, pt[i].y / cheight);
		int src_x = (index % Game->GetBitCount()) * cwidth;
		int src_y = (index / Game->GetBitCount()) * cheight;
		//⓹̓蔻肪Ȃ͏̓蔻sB
		if (src_x == 0 && src_y == 0) {
			res.x = pt[i].x / cwidth; // ǂ̍W
			res.y = pt[i].y / cheight;
			return res; // ǂ̍WԂ
		}
	}
	res.x = -1;
	res.y = -1;
	return res;
}

Vector2 CCollision::CheckSlope(float x, float y, Segment& Slope, int layernum,int slopecond) {
	Segment Player = SetSegment((int)x, (int)y, slopecond);
	Vector2 res = { x,y };
	//fobOpB
	float T1;
	float T2;
	Vector2 Vres;
	int PlayerCond;
	//vC[̑A⓹̊Jnn_ƏIn_̊ԂȂA1BԂłȂ̂ȂA0B
	if (Slope.s.x >= Player.v.x && Player.v.x < Slope.v.x || Slope.s.x <= Player.v.x && Player.v.x > Slope.v.x) {
		PlayerCond = 1;
	}
	else {
		PlayerCond = 0;
	}
	//Փ˂ꍇ͍Wɓ𑫂AłȂꍇ͓B
	//iԈĂ邩ȂcBj
	if (PlayerCond != 0){
		if (ColSegments(Slope,Player,&T1,&T2,&Vres)) {
			res.x = x + T1;
			res.y = y + T1;
			return res;
		}
		else {
			res.x = x - T1;
			res.y = y - T1;
			return res;
		}
	}

	//܂ŗՓ˂ĂȂƂƁB
	res.x = -1;
	res.y = -1;
	return res;
}

Segment CCollision::SetSegment(int x, int y, int slopecond) {
	//蔻B
	POINT pt[] = {
		{ x + mPt[0].x,	y + mPt[0].y },//
		{ x + mPt[1].x,	y + mPt[1].y },//^
		{ x + mPt[2].x,	y + mPt[2].y },//E

		{ x + mPt[3].x,	y + mPt[3].y },//^
		{ x + mPt[4].x,	y + mPt[4].y },//E^

		{ x + mPt[5].x,	y + mPt[5].y },//
		{ x + mPt[6].x,	y + mPt[6].y },//^
		{ x + mPt[7].x,	y + mPt[7].y },//E
	};
	DWORD cwidth = Game->MapData().GetChipWidth();
	DWORD cheight = Game->MapData().GetChipHeight();
	Segment res;
	switch (slopecond) {
		//1͉̉B
	case 1:
		res.s = { (float)pt[2].x,(float)pt[2].y };
		res.v = { (float)pt[5].x,(float)pt[5].y };
		break;
		//2͏̏B
	case 2:
		res.s = { (float)pt[7].x,(float)pt[7].y };
		res.v = { (float)pt[0].x,(float)pt[0].y };
		break;
		//3͏̏B
	case 3:
		res.s = { (float)pt[5].x,(float)pt[5].y };
		res.v = { (float)pt[2].x,(float)pt[2].y };
		break;
		//0͉̏Bi0ȊO͑z肵ĂȂ̂Bj
	default:
		res.s = { (float)pt[0].x,(float)pt[0].y };
		res.v = { (float)pt[7].x,(float)pt[7].y };
		break;
	}
	return res;
}

Segment CCollision::SetSlopeSeg(int x, int y, int layer, int* cond) {
	Segment res;
	switch (layer) {
		//STx̏B
	case 2:
		res.s = GetMatrixPos(x, y + 16.0F);
		res.v = GetMatrixPos(x + 16.0F, y);
		*cond = 0;
		break;
		//ubNIB
	default:
		ColType = TypeBLOCK;
		*cond = -1;
		break;
	}
	return res;
}

void CCollision::GetSlope(float* myx, float* myy, int* jcount, bool* gflag) {
	SlopeCollision(myx, myy, jcount, gflag);
}

void CCollision::SlopeCollision(float* myx, float* myy, int* jcount, bool* gflag) {
	//ubÑC[ԍ̊lB
	int Layer = GetChipLayerNum((int)*myx, (int)*myy);
	//̕ϐ̐錾B
	Segment Slope;
	//X[v̏BĂȂƍ⓹̓蔻ɓƂɗOfo܂B
	int SlopeCond = 0;
	Slope = SetSlopeSeg(*myx, *myy, Layer, &SlopeCond);
	Vector2 slope = CheckSlope(*myx, *myy, Slope, Layer, SlopeCond);
	const int NG = -1;
	const int BLOCK = -2;
	if (slope.y != NG) {
		*myy = slope.y;
	}
	else if (slope.x == BLOCK) {
		//Ŏlp`ƂĂ̓蔻sB
	}
	*gflag = true;
	*jcount = 0;
}

void CCollision::GetXPosition(float* myx, float* myy) {
	//ubNƂĂ̏Փ˔B
	POINT block = CheckMap((int)*myx, *myy);
	const float OK = -1.0F;
	const float SLOPE = -2.0F;
	//XWՓ˂ĂȂB
	if (block.x == OK) {
		ColType = TypeBLOCK;
	}
	//XW⓹̃C[ɂB
	else if (block.x == SLOPE) {
		ColType = TypeSLOPE;
	}
	//ubN̓蔻B
	else {
		ColType = TypeBLOCK;
		int brpos = ((block.x - 1) * 16);
		int blpos = ((block.x + 1) * 16);
		bool Debug = true;
		if (blpos > *myx) {
			*myx = (float)((block.x - 1) * 16 + 8 + OffsetR - 0.1f);
		}
		else if (brpos < *myx){
			*myx = (float)((block.x + 1) * 16 + 8 + OffsetL + 0.1f);
		}
	}
}

void CCollision::GetYPosition(float* myx, float* myy,int* jcount,bool* gflag) {
	//ubNƂĂ̏Փ˔B
	POINT block = CheckMap((int)*myx, (int)*myy);
	const float OK = -1.0F;
	const float SLOPE = -2.0F;
	//YWՓ˂ĂȂB
	if (block.y == OK) {
		ColType = TypeBLOCK;
	}
	//YW⓹̃C[ɂB
	else if (block.y == SLOPE) {
		ColType = TypeSLOPE;
		*gflag = false;
	}
	//ubN̓蔻B
	else {
		ColType = TypeBLOCK;
		int btpos = (block.y - 1) * 16;
		int bbpos = (block.y + 1) * 16;
		int brpos = (block.x - 1) * 16;
		int blpos = (block.x + 1) * 16;
		bool Debug = true;
		if (btpos < *myy) {
			*myy = (float)((block.y - 1) * 16 + 8 + OffsetD - 0.1f);
			*jcount = 0;
			*gflag = true;			
		}
		if (bbpos > *myy) {	
			*myy = (float)((block.y + 1) * 16 + 8 + OffsetU + 0.1f);
		}
	}
}

void CCollision::GetMove(float* myx, float* myy,int* jcount, bool* gflag) {
	if (ColType == TypeBLOCK) {
		GetXPosition(myx, myy);
	}

	if (ColType == TypeBLOCK) {
		GetYPosition(myx, myy,jcount,gflag);
	}
}